Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs_ops.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -858,133 +454,207 @@
 	
 	/* Unlock the VFS node. */
-	if ((read) ||
-	    ((fs_info->concurrent_read_write) && (fs_info->write_retains_size)))
+	if (rlock) {
 		fibril_rwlock_read_unlock(&file->node->contents_rwlock);
-	else {
+	} else {
 		/* Update the cached version of node's size. */
-		if (rc == EOK)
+		if (rc == EOK) {
 			file->node->size = MERGE_LOUP32(IPC_GET_ARG2(answer),
 			    IPC_GET_ARG3(answer));
+		}
 		fibril_rwlock_write_unlock(&file->node->contents_rwlock);
 	}
 	
-	/* Update the position pointer and unlock the open file. */
+	vfs_file_put(file);	
+
+	return rc;
+}
+
+int vfs_rdwr_internal(int fd, aoff64_t pos, bool read, rdwr_io_chunk_t *chunk)
+{
+	return vfs_rdwr(fd, pos, read, rdwr_ipc_internal, chunk);
+}
+
+int vfs_op_read(int fd, aoff64_t pos, size_t *out_bytes)
+{
+	return vfs_rdwr(fd, pos, true, rdwr_ipc_client, out_bytes);
+}
+
+int vfs_op_rename(int basefd, char *old, char *new)
+{
+	vfs_file_t *base_file = vfs_file_get(basefd);
+	if (!base_file)
+		return EBADF;
+
+	vfs_node_t *base = base_file->node;
+	vfs_node_addref(base);
+	vfs_file_put(base_file);
+	
+	vfs_lookup_res_t base_lr;
+	vfs_lookup_res_t old_lr;
+	vfs_lookup_res_t new_lr_orig;
+	bool orig_unlinked = false;
+	
+	int rc;
+	
+	size_t shared = shared_path(old, new);
+	
+	/* Do not allow one path to be a prefix of the other. */
+	if (old[shared] == 0 || new[shared] == 0) {
+		vfs_node_put(base);
+		return EINVAL;
+	}
+	assert(old[shared] == '/');
+	assert(new[shared] == '/');
+	
+	fibril_rwlock_write_lock(&namespace_rwlock);
+	
+	/* Resolve the shared portion of the path first. */
+	if (shared != 0) {
+		old[shared] = 0;
+		rc = vfs_lookup_internal(base, old, L_DIRECTORY, &base_lr);
+		if (rc != EOK) {
+			vfs_node_put(base);
+			fibril_rwlock_write_unlock(&namespace_rwlock);
+			return rc;
+		}
+		
+		vfs_node_put(base);
+		base = vfs_node_get(&base_lr);
+		if (!base) {
+			fibril_rwlock_write_unlock(&namespace_rwlock);
+			return ENOMEM;
+		}
+		old[shared] = '/';
+		old += shared;
+		new += shared;
+	}
+
+	rc = vfs_lookup_internal(base, old, L_DISABLE_MOUNTS, &old_lr);
+	if (rc != EOK) {
+		vfs_node_put(base);
+		fibril_rwlock_write_unlock(&namespace_rwlock);
+		return rc;
+	}
+		
+	rc = vfs_lookup_internal(base, new, L_UNLINK | L_DISABLE_MOUNTS,
+	    &new_lr_orig);
+	if (rc == EOK) {
+		orig_unlinked = true;
+	} else if (rc != ENOENT) {
+		vfs_node_put(base);
+		fibril_rwlock_write_unlock(&namespace_rwlock);
+		return rc;
+	}
+
+	rc = vfs_link_internal(base, new, &old_lr.triplet);
+	if (rc != EOK) {
+		vfs_link_internal(base, old, &old_lr.triplet);
+		if (orig_unlinked)
+			vfs_link_internal(base, new, &new_lr_orig.triplet);
+		vfs_node_put(base);
+		fibril_rwlock_write_unlock(&namespace_rwlock);
+		return rc;
+	}
+
+	rc = vfs_lookup_internal(base, old, L_UNLINK | L_DISABLE_MOUNTS,
+	    &old_lr);
+	if (rc != EOK) {
+		if (orig_unlinked)
+			vfs_link_internal(base, new, &new_lr_orig.triplet);
+		vfs_node_put(base);
+		fibril_rwlock_write_unlock(&namespace_rwlock);
+		return rc;
+	}
+	
+	/* If the node is not held by anyone, try to destroy it. */
+	if (orig_unlinked) {
+		vfs_node_t *node = vfs_node_peek(&new_lr_orig);
+		if (!node)
+			out_destroy(&new_lr_orig.triplet);
+		else
+			vfs_node_put(node);
+	}
+	
+	vfs_node_put(base);
+	fibril_rwlock_write_unlock(&namespace_rwlock);
+	return EOK;
+}
+
+int vfs_op_resize(int fd, int64_t size)
+{
+	vfs_file_t *file = vfs_file_get(fd);
+	if (!file)
+		return EBADF;
+
+	fibril_rwlock_write_lock(&file->node->contents_rwlock);
+	
+	int rc = vfs_truncate_internal(file->node->fs_handle,
+	    file->node->service_id, file->node->index, size);
 	if (rc == EOK)
-		file->pos += bytes;
-	fibril_mutex_unlock(&file->lock);
-	vfs_file_put(file);	
-
+		file->node->size = size;
+	
+	fibril_rwlock_write_unlock(&file->node->contents_rwlock);
+	vfs_file_put(file);
 	return rc;
 }
-	
-static void vfs_rdwr_client(ipc_callid_t rid, ipc_call_t *request, bool read)
-{
-	size_t bytes = 0;	
-	int rc = vfs_rdwr(IPC_GET_ARG1(*request), read, rdwr_ipc_client,
-	    &bytes);
-	async_answer_1(rid, rc, bytes);
-}
-
-int vfs_rdwr_internal(int fd, bool read, rdwr_io_chunk_t *chunk)
-{
-	return vfs_rdwr(fd, read, rdwr_ipc_internal, chunk);
-}
-
-void vfs_read(ipc_callid_t rid, ipc_call_t *request)
-{
-	vfs_rdwr_client(rid, request, true);
-}
-
-void vfs_write(ipc_callid_t rid, ipc_call_t *request)
-{
-	vfs_rdwr_client(rid, request, false);
-}
-
-void vfs_seek(ipc_callid_t rid, ipc_call_t *request)
-{
-	int fd = (int) IPC_GET_ARG1(*request);
-	off64_t off = (off64_t) MERGE_LOUP32(IPC_GET_ARG2(*request),
-	    IPC_GET_ARG3(*request));
-	int whence = (int) IPC_GET_ARG4(*request);
-	
-	/* Lookup the file structure corresponding to the file descriptor. */
+
+int vfs_op_stat(int fd)
+{
 	vfs_file_t *file = vfs_file_get(fd);
-	if (!file) {
-		async_answer_0(rid, ENOENT);
-		return;
-	}
-	
-	fibril_mutex_lock(&file->lock);
-	
-	off64_t newoff;
-	switch (whence) {
-	case SEEK_SET:
-		if (off >= 0) {
-			file->pos = (aoff64_t) off;
-			fibril_mutex_unlock(&file->lock);
-			vfs_file_put(file);
-			async_answer_1(rid, EOK, off);
-			return;
-		}
-		break;
-	case SEEK_CUR:
-		if ((off >= 0) && (file->pos + off < file->pos)) {
-			fibril_mutex_unlock(&file->lock);
-			vfs_file_put(file);
-			async_answer_0(rid, EOVERFLOW);
-			return;
-		}
-		
-		if ((off < 0) && (file->pos < (aoff64_t) -off)) {
-			fibril_mutex_unlock(&file->lock);
-			vfs_file_put(file);
-			async_answer_0(rid, EOVERFLOW);
-			return;
-		}
-		
-		file->pos += off;
-		newoff = (file->pos > OFF64_MAX) ? OFF64_MAX : file->pos;
-		
-		fibril_mutex_unlock(&file->lock);
-		vfs_file_put(file);
-		async_answer_2(rid, EOK, LOWER32(newoff),
-		    UPPER32(newoff));
-		return;
-	case SEEK_END:
-		fibril_rwlock_read_lock(&file->node->contents_rwlock);
-		aoff64_t size = file->node->size;
-		
-		if ((off >= 0) && (size + off < size)) {
-			fibril_rwlock_read_unlock(&file->node->contents_rwlock);
-			fibril_mutex_unlock(&file->lock);
-			vfs_file_put(file);
-			async_answer_0(rid, EOVERFLOW);
-			return;
-		}
-		
-		if ((off < 0) && (size < (aoff64_t) -off)) {
-			fibril_rwlock_read_unlock(&file->node->contents_rwlock);
-			fibril_mutex_unlock(&file->lock);
-			vfs_file_put(file);
-			async_answer_0(rid, EOVERFLOW);
-			return;
-		}
-		
-		file->pos = size + off;
-		newoff = (file->pos > OFF64_MAX) ?  OFF64_MAX : file->pos;
-		
-		fibril_rwlock_read_unlock(&file->node->contents_rwlock);
-		fibril_mutex_unlock(&file->lock);
-		vfs_file_put(file);
-		async_answer_2(rid, EOK, LOWER32(newoff), UPPER32(newoff));
-		return;
-	}
-	
-	fibril_mutex_unlock(&file->lock);
+	if (!file)
+		return EBADF;
+
+	vfs_node_t *node = file->node;
+
+	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
+	int rc = async_data_read_forward_fast(exch, VFS_OUT_STAT,
+	    node->service_id, node->index, true, 0, NULL);
+	vfs_exchange_release(exch);
+	
 	vfs_file_put(file);
-	async_answer_0(rid, EINVAL);
-}
-
-int vfs_truncate_internal(fs_handle_t fs_handle, service_id_t service_id,
+	return rc;
+}
+
+int vfs_op_statfs(int fd)
+{
+	vfs_file_t *file = vfs_file_get(fd);
+	if (!file)
+		return EBADF;
+
+	vfs_node_t *node = file->node;
+
+	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
+	int rc = async_data_read_forward_fast(exch, VFS_OUT_STATFS,
+	    node->service_id, node->index, false, 0, NULL);
+	vfs_exchange_release(exch);
+
+	vfs_file_put(file);
+	return rc;
+}
+
+int vfs_op_sync(int fd)
+{
+	vfs_file_t *file = vfs_file_get(fd);
+	if (!file)
+		return EBADF;
+	
+	async_exch_t *fs_exch = vfs_exchange_grab(file->node->fs_handle);
+	
+	aid_t msg;
+	ipc_call_t answer;
+	msg = async_send_2(fs_exch, VFS_OUT_SYNC, file->node->service_id,
+	    file->node->index, &answer);
+	
+	vfs_exchange_release(fs_exch);
+	
+	sysarg_t rc;
+	async_wait_for(msg, &rc);
+	
+	vfs_file_put(file);
+	return rc;
+	
+}
+
+static int vfs_truncate_internal(fs_handle_t fs_handle, service_id_t service_id,
     fs_index_t index, aoff64_t size)
 {
@@ -998,526 +668,222 @@
 }
 
-void vfs_truncate(ipc_callid_t rid, ipc_call_t *request)
-{
-	int fd = IPC_GET_ARG1(*request);
-	aoff64_t size = (aoff64_t) MERGE_LOUP32(IPC_GET_ARG2(*request),
-	    IPC_GET_ARG3(*request));
-	int rc;
-
-	vfs_file_t *file = vfs_file_get(fd);
-	if (!file) {
-		async_answer_0(rid, ENOENT);
-		return;
-	}
-	fibril_mutex_lock(&file->lock);
-
-	fibril_rwlock_write_lock(&file->node->contents_rwlock);
-	rc = vfs_truncate_internal(file->node->fs_handle,
-	    file->node->service_id, file->node->index, size);
-	if (rc == EOK)
-		file->node->size = size;
-	fibril_rwlock_write_unlock(&file->node->contents_rwlock);
-
-	fibril_mutex_unlock(&file->lock);
-	vfs_file_put(file);
-	async_answer_0(rid, (sysarg_t)rc);
-}
-
-void vfs_fstat(ipc_callid_t rid, ipc_call_t *request)
-{
-	int fd = IPC_GET_ARG1(*request);
-	sysarg_t rc;
-
-	vfs_file_t *file = vfs_file_get(fd);
-	if (!file) {
-		async_answer_0(rid, ENOENT);
-		return;
-	}
-
-	ipc_callid_t callid;
-	if (!async_data_read_receive(&callid, NULL)) {
-		vfs_file_put(file);
-		async_answer_0(callid, EINVAL);
-		async_answer_0(rid, EINVAL);
-		return;
-	}
-
-	fibril_mutex_lock(&file->lock);
-
-	async_exch_t *exch = vfs_exchange_grab(file->node->fs_handle);
-	
-	aid_t msg;
-	msg = async_send_3(exch, VFS_OUT_STAT, file->node->service_id,
-	    file->node->index, true, NULL);
-	async_forward_fast(callid, exch, 0, 0, 0, IPC_FF_ROUTE_FROM_ME);
-	
+int vfs_op_unlink(int parentfd, int expectfd, char *path)
+{
+	int rc = EOK;
+	vfs_file_t *parent = NULL;
+	vfs_file_t *expect = NULL;
+	
+	if (parentfd == expectfd)
+		return EINVAL;
+	
+	fibril_rwlock_write_lock(&namespace_rwlock);
+	
+	/* 
+	 * Files are retrieved in order of file descriptors, to prevent
+	 * deadlock.
+	 */
+	if (parentfd < expectfd) {
+		parent = vfs_file_get(parentfd);
+		if (!parent) {
+			rc = EBADF;
+			goto exit;
+		}
+	}
+	
+	if (expectfd >= 0) {
+		expect = vfs_file_get(expectfd);
+		if (!expect) {
+			rc = EBADF;
+			goto exit;
+		}
+	}
+	
+	if (parentfd > expectfd) {
+		parent = vfs_file_get(parentfd);
+		if (!parent) {
+			rc = EBADF;
+			goto exit;
+		}
+	}
+	
+	assert(parent != NULL);
+	
+	if (expectfd >= 0) {
+		vfs_lookup_res_t lr;
+		rc = vfs_lookup_internal(parent->node, path, 0, &lr);
+		if (rc != EOK)
+			goto exit;
+		
+		vfs_node_t *found_node = vfs_node_peek(&lr);
+		vfs_node_put(found_node);
+		if (expect->node != found_node) {
+			rc = ENOENT;
+			goto exit;
+		}
+		
+		vfs_file_put(expect);
+		expect = NULL;
+	}
+	
+	vfs_lookup_res_t lr;
+	rc = vfs_lookup_internal(parent->node, path, L_UNLINK, &lr);
+	if (rc != EOK)
+		goto exit;
+
+	/* If the node is not held by anyone, try to destroy it. */
+	vfs_node_t *node = vfs_node_peek(&lr);
+	if (!node)
+		out_destroy(&lr.triplet);
+	else
+		vfs_node_put(node);
+
+exit:
+	if (path)
+		free(path);
+	if (parent)
+		vfs_file_put(parent);
+	if (expect)
+		vfs_file_put(expect);
+	fibril_rwlock_write_unlock(&namespace_rwlock);
+	return rc;
+}
+
+int vfs_op_unmount(int mpfd)
+{
+	vfs_file_t *mp = vfs_file_get(mpfd);
+	if (mp == NULL)
+		return EBADF;
+	
+	if (mp->node->mount == NULL) {
+		vfs_file_put(mp);
+		return ENOENT;
+	}
+	
+	fibril_rwlock_write_lock(&namespace_rwlock);
+	
+	/*
+	 * Count the total number of references for the mounted file system. We
+	 * are expecting at least one, which is held by the mount point.
+	 * If we find more, it means that
+	 * the file system cannot be gracefully unmounted at the moment because
+	 * someone is working with it.
+	 */
+	if (vfs_nodes_refcount_sum_get(mp->node->mount->fs_handle,
+	    mp->node->mount->service_id) != 1) {
+		vfs_file_put(mp);
+		fibril_rwlock_write_unlock(&namespace_rwlock);
+		return EBUSY;
+	}
+	
+	async_exch_t *exch = vfs_exchange_grab(mp->node->mount->fs_handle);
+	int rc = async_req_1_0(exch, VFS_OUT_UNMOUNTED,
+	    mp->node->mount->service_id);
 	vfs_exchange_release(exch);
 	
-	async_wait_for(msg, &rc);
-	
-	fibril_mutex_unlock(&file->lock);
-	vfs_file_put(file);
-	async_answer_0(rid, rc);
-}
-
-void vfs_stat(ipc_callid_t rid, ipc_call_t *request)
-{
-	char *path;
-	int rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
 	if (rc != EOK) {
-		async_answer_0(rid, rc);
-		return;
-	}
-	
-	ipc_callid_t callid;
-	if (!async_data_read_receive(&callid, NULL)) {
-		free(path);
-		async_answer_0(callid, EINVAL);
-		async_answer_0(rid, EINVAL);
-		return;
-	}
-
+		vfs_file_put(mp);
+		fibril_rwlock_write_unlock(&namespace_rwlock);
+		return rc;
+	}
+	
+	vfs_node_forget(mp->node->mount);
+	vfs_node_put(mp->node);
+	mp->node->mount = NULL;
+	
+	fibril_rwlock_write_unlock(&namespace_rwlock);
+	
+	vfs_file_put(mp);
+	return EOK;
+}
+
+int vfs_op_wait_handle(bool high_fd)
+{
+	return vfs_wait_handle_internal(high_fd);
+}
+
+static inline bool walk_flags_valid(int flags)
+{
+	if ((flags & ~WALK_ALL_FLAGS) != 0)
+		return false;
+	if ((flags & WALK_MAY_CREATE) && (flags & WALK_MUST_CREATE))
+		return false;
+	if ((flags & WALK_REGULAR) && (flags & WALK_DIRECTORY))
+		return false;
+	if ((flags & WALK_MAY_CREATE) || (flags & WALK_MUST_CREATE)) {
+		if (!(flags & WALK_DIRECTORY) && !(flags & WALK_REGULAR))
+			return false;
+	}
+	return true;
+}
+
+static inline int walk_lookup_flags(int flags)
+{
+	int lflags = 0;
+	if ((flags & WALK_MAY_CREATE) || (flags & WALK_MUST_CREATE))
+		lflags |= L_CREATE;
+	if (flags & WALK_MUST_CREATE)
+		lflags |= L_EXCLUSIVE;
+	if (flags & WALK_REGULAR)
+		lflags |= L_FILE;
+	if (flags & WALK_DIRECTORY)
+		lflags |= L_DIRECTORY;
+	if (flags & WALK_MOUNT_POINT)
+		lflags |= L_MP;
+	return lflags;
+}
+
+int vfs_op_walk(int parentfd, int flags, char *path, int *out_fd)
+{
+	if (!walk_flags_valid(flags))
+		return EINVAL;
+	
+	vfs_file_t *parent = vfs_file_get(parentfd);
+	if (!parent)
+		return EBADF;
+	
+	fibril_rwlock_read_lock(&namespace_rwlock);
+	
 	vfs_lookup_res_t lr;
-	fibril_rwlock_read_lock(&namespace_rwlock);
-	rc = vfs_lookup_internal(path, L_NONE, &lr, NULL);
-	free(path);
+	int rc = vfs_lookup_internal(parent->node, path,
+	    walk_lookup_flags(flags), &lr);
 	if (rc != EOK) {
 		fibril_rwlock_read_unlock(&namespace_rwlock);
-		async_answer_0(callid, rc);
-		async_answer_0(rid, rc);
-		return;
-	}
+		vfs_file_put(parent);
+		return rc;
+	}
+	
 	vfs_node_t *node = vfs_node_get(&lr);
 	if (!node) {
 		fibril_rwlock_read_unlock(&namespace_rwlock);
-		async_answer_0(callid, ENOMEM);
-		async_answer_0(rid, ENOMEM);
-		return;
-	}
-
+		vfs_file_put(parent);
+		return ENOMEM;
+	}
+	
+	vfs_file_t *file;
+	int fd = vfs_fd_alloc(&file, false);
+	if (fd < 0) {
+		vfs_node_put(node);
+		vfs_file_put(parent);
+		return fd;
+	}
+	assert(file != NULL);
+	
+	file->node = node;
+	file->permissions = parent->permissions;
+	file->open_read = false;
+	file->open_write = false;
+	
+	vfs_file_put(file);
+	vfs_file_put(parent);
+	
 	fibril_rwlock_read_unlock(&namespace_rwlock);
 
-	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-	
-	aid_t msg;
-	msg = async_send_3(exch, VFS_OUT_STAT, node->service_id,
-	    node->index, false, NULL);
-	async_forward_fast(callid, exch, 0, 0, 0, IPC_FF_ROUTE_FROM_ME);
-	
-	vfs_exchange_release(exch);
-	
-	sysarg_t rv;
-	async_wait_for(msg, &rv);
-
-	async_answer_0(rid, rv);
-
-	vfs_node_put(node);
-}
-
-void vfs_mkdir(ipc_callid_t rid, ipc_call_t *request)
-{
-	int mode = IPC_GET_ARG1(*request);
-	
-	char *path;
-	int rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
-	if (rc != EOK) {
-		async_answer_0(rid, rc);
-		return;
-	}
-	
-	/* Ignore mode for now. */
-	(void) mode;
-	
-	fibril_rwlock_write_lock(&namespace_rwlock);
-	int lflag = L_DIRECTORY | L_CREATE | L_EXCLUSIVE;
-	rc = vfs_lookup_internal(path, lflag, NULL, NULL);
-	fibril_rwlock_write_unlock(&namespace_rwlock);
-	free(path);
-	async_answer_0(rid, rc);
-}
-
-void vfs_unlink(ipc_callid_t rid, ipc_call_t *request)
-{
-	int lflag = IPC_GET_ARG1(*request);
-	
-	char *path;
-	int rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
-	if (rc != EOK) {
-		async_answer_0(rid, rc);
-		return;
-	}
-	
-	fibril_rwlock_write_lock(&namespace_rwlock);
-	lflag &= L_DIRECTORY;	/* sanitize lflag */
-	vfs_lookup_res_t lr;
-	rc = vfs_lookup_internal(path, lflag | L_UNLINK, &lr, NULL);
-	free(path);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		async_answer_0(rid, rc);
-		return;
-	}
-
-	/*
-	 * The name has already been unlinked by vfs_lookup_internal().
-	 * We have to get and put the VFS node to ensure that it is
-	 * VFS_OUT_DESTROY'ed after the last reference to it is dropped.
-	 */
-	vfs_node_t *node = vfs_node_get(&lr);
-	fibril_mutex_lock(&nodes_mutex);
-	node->lnkcnt--;
-	fibril_mutex_unlock(&nodes_mutex);
-	fibril_rwlock_write_unlock(&namespace_rwlock);
-	vfs_node_put(node);
-	async_answer_0(rid, EOK);
-}
-
-void vfs_rename(ipc_callid_t rid, ipc_call_t *request)
-{
-	/* Retrieve the old path. */
-	char *old;
-	int rc = async_data_write_accept((void **) &old, true, 0, 0, 0, NULL);
-	if (rc != EOK) {
-		async_answer_0(rid, rc);
-		return;
-	}
-	
-	/* Retrieve the new path. */
-	char *new;
-	rc = async_data_write_accept((void **) &new, true, 0, 0, 0, NULL);
-	if (rc != EOK) {
-		free(old);
-		async_answer_0(rid, rc);
-		return;
-	}
-	
-	size_t olen;
-	size_t nlen;
-	char *oldc = canonify(old, &olen);
-	char *newc = canonify(new, &nlen);
-	
-	if ((!oldc) || (!newc)) {
-		async_answer_0(rid, EINVAL);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	oldc[olen] = '\0';
-	newc[nlen] = '\0';
-	
-	if ((!str_lcmp(newc, oldc, str_length(oldc))) &&
-	    ((newc[str_length(oldc)] == '/') ||
-	    (str_length(oldc) == 1) ||
-	    (str_length(oldc) == str_length(newc)))) {
-	    	/*
-		 * oldc is a prefix of newc and either
-		 * - newc continues with a / where oldc ends, or
-		 * - oldc was / itself, or
-		 * - oldc and newc are equal.
-		 */
-		async_answer_0(rid, EINVAL);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	vfs_lookup_res_t old_lr;
-	vfs_lookup_res_t new_lr;
-	vfs_lookup_res_t new_par_lr;
-	fibril_rwlock_write_lock(&namespace_rwlock);
-	
-	/* Lookup the node belonging to the old file name. */
-	rc = vfs_lookup_internal(oldc, L_NONE, &old_lr, NULL);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		async_answer_0(rid, rc);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	vfs_node_t *old_node = vfs_node_get(&old_lr);
-	if (!old_node) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		async_answer_0(rid, ENOMEM);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	/* Determine the path to the parent of the node with the new name. */
-	char *parentc = str_dup(newc);
-	if (!parentc) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
-		async_answer_0(rid, rc);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	char *lastsl = str_rchr(parentc + 1, '/');
-	if (lastsl)
-		*lastsl = '\0';
-	else
-		parentc[1] = '\0';
-	
-	/* Lookup parent of the new file name. */
-	rc = vfs_lookup_internal(parentc, L_NONE, &new_par_lr, NULL);
-	free(parentc);	/* not needed anymore */
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
-		async_answer_0(rid, rc);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	/* Check whether linking to the same file system instance. */
-	if ((old_node->fs_handle != new_par_lr.triplet.fs_handle) ||
-	    (old_node->service_id != new_par_lr.triplet.service_id)) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
-		async_answer_0(rid, EXDEV);	/* different file systems */
-		free(old);
-		free(new);
-		return;
-	}
-	
-	/* Destroy the old link for the new name. */
-	vfs_node_t *new_node = NULL;
-	rc = vfs_lookup_internal(newc, L_UNLINK, &new_lr, NULL);
-	
-	switch (rc) {
-	case ENOENT:
-		/* simply not in our way */
-		break;
-	case EOK:
-		new_node = vfs_node_get(&new_lr);
-		if (!new_node) {
-			fibril_rwlock_write_unlock(&namespace_rwlock);
-			vfs_node_put(old_node);
-			async_answer_0(rid, ENOMEM);
-			free(old);
-			free(new);
-			return;
-		}
-		fibril_mutex_lock(&nodes_mutex);
-		new_node->lnkcnt--;
-		fibril_mutex_unlock(&nodes_mutex);
-		break;
-	default:
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
-		async_answer_0(rid, ENOTEMPTY);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	/* Create the new link for the new name. */
-	rc = vfs_lookup_internal(newc, L_LINK, NULL, NULL, old_node->index);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
-		if (new_node)
-			vfs_node_put(new_node);
-		async_answer_0(rid, rc);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	fibril_mutex_lock(&nodes_mutex);
-	old_node->lnkcnt++;
-	fibril_mutex_unlock(&nodes_mutex);
-	
-	/* Destroy the link for the old name. */
-	rc = vfs_lookup_internal(oldc, L_UNLINK, NULL, NULL);
-	if (rc != EOK) {
-		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
-		if (new_node)
-			vfs_node_put(new_node);
-		async_answer_0(rid, rc);
-		free(old);
-		free(new);
-		return;
-	}
-	
-	fibril_mutex_lock(&nodes_mutex);
-	old_node->lnkcnt--;
-	fibril_mutex_unlock(&nodes_mutex);
-	fibril_rwlock_write_unlock(&namespace_rwlock);
-	vfs_node_put(old_node);
-	
-	if (new_node)
-		vfs_node_put(new_node);
-	
-	free(old);
-	free(new);
-	async_answer_0(rid, EOK);
-}
-
-void vfs_dup(ipc_callid_t rid, ipc_call_t *request)
-{
-	int oldfd = IPC_GET_ARG1(*request);
-	int newfd = IPC_GET_ARG2(*request);
-	
-	/* If the file descriptors are the same, do nothing. */
-	if (oldfd == newfd) {
-		async_answer_1(rid, EOK, newfd);
-		return;
-	}
-	
-	/* Lookup the file structure corresponding to oldfd. */
-	vfs_file_t *oldfile = vfs_file_get(oldfd);
-	if (!oldfile) {
-		async_answer_0(rid, EBADF);
-		return;
-	}
-	
-	/*
-	 * Lock the open file structure so that no other thread can manipulate
-	 * the same open file at a time.
-	 */
-	fibril_mutex_lock(&oldfile->lock);
-	
-	/* Make sure newfd is closed. */
-	(void) vfs_fd_free(newfd);
-	
-	/* Assign the old file to newfd. */
-	int ret = vfs_fd_assign(oldfile, newfd);
-	fibril_mutex_unlock(&oldfile->lock);
-	vfs_file_put(oldfile);
-	
-	if (ret != EOK)
-		async_answer_0(rid, ret);
-	else
-		async_answer_1(rid, EOK, newfd);
-}
-
-void vfs_wait_handle(ipc_callid_t rid, ipc_call_t *request)
-{
-	int fd = vfs_wait_handle_internal();
-	async_answer_1(rid, EOK, fd);
-}
-
-void vfs_get_mtab(ipc_callid_t rid, ipc_call_t *request)
-{
-	ipc_callid_t callid;
-	ipc_call_t data;
-	sysarg_t rc = EOK;
-	size_t len;
-
-	fibril_mutex_lock(&mtab_list_lock);
-
-	/* Send to the caller the number of mounted filesystems */
-	callid = async_get_call(&data);
-	if (IPC_GET_IMETHOD(data) != VFS_IN_PING) {
-		rc = ENOTSUP;
-		async_answer_0(callid, rc);
-		goto exit;
-	}
-	async_answer_1(callid, EOK, mtab_size);
-
-	list_foreach(mtab_list, link, mtab_ent_t, mtab_ent) {
-		rc = ENOTSUP;
-
-		if (!async_data_read_receive(&callid, &len)) {
-			async_answer_0(callid, rc);
-			goto exit;
-		}
-
-		(void) async_data_read_finalize(callid, mtab_ent->mp,
-		    str_size(mtab_ent->mp));
-
-		if (!async_data_read_receive(&callid, &len)) {
-			async_answer_0(callid, rc);
-			goto exit;
-		}
-
-		(void) async_data_read_finalize(callid, mtab_ent->opts,
-		    str_size(mtab_ent->opts));
-
-		if (!async_data_read_receive(&callid, &len)) {
-			async_answer_0(callid, rc);
-			goto exit;
-		}
-
-		(void) async_data_read_finalize(callid, mtab_ent->fs_name,
-		    str_size(mtab_ent->fs_name));
-
-		callid = async_get_call(&data);
-
-		if (IPC_GET_IMETHOD(data) != VFS_IN_PING) {
-			async_answer_0(callid, rc);
-			goto exit;
-		}
-
-		rc = EOK;
-		async_answer_2(callid, rc, mtab_ent->instance,
-		    mtab_ent->service_id);
-	}
-
-exit:
-	fibril_mutex_unlock(&mtab_list_lock);
-	async_answer_0(rid, rc);
-}
-
-void vfs_statfs(ipc_callid_t rid, ipc_call_t *request)
-{
-	char *path;
-	int rc = async_data_write_accept((void **) &path, true, 0, 0, 0, NULL);
-	if (rc != EOK) {
-		async_answer_0(rid, rc);
-		return;
-	}
-	
-	ipc_callid_t callid;
-	if (!async_data_read_receive(&callid, NULL)) {
-		free(path);
-		async_answer_0(callid, EINVAL);
-		async_answer_0(rid, EINVAL);
-		return;
-	}
-
-	vfs_lookup_res_t lr;
-	fibril_rwlock_read_lock(&namespace_rwlock);
-	rc = vfs_lookup_internal(path, L_NONE, &lr, NULL);
-	free(path);
-	if (rc != EOK) {
-		fibril_rwlock_read_unlock(&namespace_rwlock);
-		async_answer_0(callid, rc);
-		async_answer_0(rid, rc);
-		return;
-	}
-	vfs_node_t *node = vfs_node_get(&lr);
-	if (!node) {
-		fibril_rwlock_read_unlock(&namespace_rwlock);
-		async_answer_0(callid, ENOMEM);
-		async_answer_0(rid, ENOMEM);
-		return;
-	}
-
-	fibril_rwlock_read_unlock(&namespace_rwlock);
-
-	async_exch_t *exch = vfs_exchange_grab(node->fs_handle);
-	
-	aid_t msg;
-	msg = async_send_3(exch, VFS_OUT_STATFS, node->service_id,
-	    node->index, false, NULL);
-	async_forward_fast(callid, exch, 0, 0, 0, IPC_FF_ROUTE_FROM_ME);
-	
-	vfs_exchange_release(exch);
-	
-	sysarg_t rv;
-	async_wait_for(msg, &rv);
-
-	async_answer_0(rid, rv);
-
-	vfs_node_put(node);
+	*out_fd = fd;
+	return EOK;
+}
+
+int vfs_op_write(int fd, aoff64_t pos, size_t *out_bytes)
+{
+	return vfs_rdwr(fd, pos, false, rdwr_ipc_client, out_bytes);
 }
 
Index: uspace/srv/vfs/vfs_pager.c
===================================================================
--- uspace/srv/vfs/vfs_pager.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs_pager.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -50,10 +50,4 @@
 	int rc;
 
-	vfs_file_t *file = vfs_file_get(fd);
-	if (!file) {
-		async_answer_0(rid, ENOENT);
-		return;
-	}
-
 	page = as_area_create(AS_AREA_ANY, page_size,
 	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE,
@@ -61,5 +55,4 @@
 
 	if (page == AS_MAP_FAILED) {
-		vfs_file_put(file);
 		async_answer_0(rid, ENOMEM);
 		return;
@@ -71,11 +64,8 @@
 	};
 
-	fibril_mutex_lock(&file->lock);
-	file->pos = offset;
-	fibril_mutex_unlock(&file->lock);
-
 	size_t total = 0;
+	aoff64_t pos = offset;
 	do {
-		rc = vfs_rdwr_internal(fd, true, &chunk);
+		rc = vfs_rdwr_internal(fd, pos, true, &chunk);
 		if (rc != EOK)
 			break;
@@ -83,9 +73,8 @@
 			break;
 		total += chunk.size;
+		pos += chunk.size;
 		chunk.buffer += chunk.size;
 		chunk.size = page_size - total;
 	} while (total < page_size);
-
-	vfs_file_put(file);
 
 	async_answer_1(rid, rc, (sysarg_t) page);
Index: uspace/srv/vfs/vfs_register.c
===================================================================
--- uspace/srv/vfs/vfs_register.c	(revision 39f892a96bc81bea824b6a8cba0f953a4e2a783d)
+++ uspace/srv/vfs/vfs_register.c	(revision 368ee04b0543abf978947ce5a1ea47698bb9692f)
@@ -296,5 +296,5 @@
  *
  */
-fs_handle_t fs_name_to_handle(unsigned int instance, char *name, bool lock)
+fs_handle_t fs_name_to_handle(unsigned int instance, const char *name, bool lock)
 {
 	int handle = 0;
